#!/usr/bin/env python3
"""
[PS1] X-Men: Mutant Academy 2
File: WAD.WAD
"""
import os
from pathlib import Path
from struct import unpack, pack

with open("WAD.WAD", "rb") as f:
    b = f.read()

path_unpack = Path("WAD_unpack")
path_unpack.mkdir(exist_ok=True)

# Windows only
vgmstream = Path("vgmstream/test.exe").exists()
def to_wav(path):
    if vgmstream:
        os.system(r"vgmstream\test.exe -i {}".format(p))

count = 0
i = 0
while True:
    i = b.find(b"VAGp", i)
    if i == -1:
        break
    offset_str = "{:08X}".format(i)
    print(offset_str)
    size, = unpack(">I", b[i+0xC:i+0xC+4])
    size += 0x30 # Header
    name = "{}_{}.vag".format(offset_str, b[i+0x20:i+0x30].decode("latin_1").strip("\x00"))
    p = path_unpack / name
    p.write_bytes(b[i:i+size])

    to_wav(p)

    i += size
    count += 1

sample_rates = [11000, 11025, 11050, 18000, 22050, 22100, 44100, 48000]

for sample_rate in sample_rates:
    search_str = pack(">I", sample_rate) + b"\x00" * 0x1C
    path_unpack2 = path_unpack / str(sample_rate)
    path_unpack2.mkdir(exist_ok=True)
    i = 0
    while True:
        i = b.find(search_str, i)
        if i == -1:
            break
        i -= 0x10
        offset_str = "{:08X}".format(i)
        print(offset_str)
        size, = unpack(">I", b[i+0xC:i+0xC+4])
        size += 0x30 # Header
        name = offset_str + ".vag"
        p = path_unpack2 / name
        p.write_bytes(b"VAGp" + b[i+4:i+4+size])

        to_wav(p)

        i += size
        count += 1

print("Found: {} files".format(count))
